fc099d0aa6aaffe2924367cea03125f98e4c5e3f
[ric-app/mc.git] / sidecars / listener / run_unit_test.ksh
1 #!/usr/bin/env bash
2
3 #==================================================================================
4 #        Copyright (c) 2018-2019 AT&T Intellectual Property.
5 #
6 #   Licensed under the Apache License, Version 2.0 (the "License");
7 #   you may not use this file except in compliance with the License.
8 #   You may obtain a copy of the License at
9 #
10 #       http://www.apache.org/licenses/LICENSE-2.0
11 #
12 #   Unless required by applicable law or agreed to in writing, software
13 #   distributed under the License is distributed on an "AS IS" BASIS,
14 #   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15 #   See the License for the specific language governing permissions and
16 #   limitations under the License.
17 #==================================================================================
18
19
20 #
21 #       Mnemonic:       run_unit_test.ksh
22 #       Abstract:       This drives unit testing setting up working directories
23 #                               and such. This expects that RMR dev package(s) is/are
24 #                               installed. Some CI envirpnments don't provide this, or
25 #                               the ability to pre-install before running this test, so
26 #                               we will force one to be there if we don't find it in /usr.
27 #
28 #       Date:           10 December 2019
29 #       Author:         E. Scott Daniels
30 # -------------------------------------------------------------------------
31
32 function abort_after {
33         touch $running
34         sleep ${1:-60}
35         if [[ -e $running ]]
36         then
37                 echo "abort: unit test running too long, killing ${2:-nojobgiven}"
38                 kill -9 ${2:-bad-pid}
39         fi
40 }
41
42 function setup_dirs {
43         mkdir -p /tmp/fifos
44         mkdir -p /tmp/mc_listener_test/final
45         mkdir -p /tmp/mc_listener_test/stage
46
47         mv_src=/tmp/mc_listener_test/mv_src             # source that will be renamed rather than copied
48         mv_dest=/tmp/mc_listener_test/mv_dest
49         ps -elf >$mv_src
50
51         copy_src=/tmp/mc_listener_test/copy_src
52         copy_dest=/tmp/mc_listener_test/copy_dest
53         ps -elf >$copy_src
54
55         src_md5=$( cat $copy_src | md5sum )             # use cat so that filename doesn't factor in to output
56         rm -f $copy_dest
57 }
58
59 function purge_dirs {
60         rm -fr /tmp/mc_listener_test
61 }
62
63 # This is a hack! There seems not to be an easy way to have the LF
64 # environment add RMR (or other needed packages) for testing. If we don't
65 # find RMR in the /usr/local part of the filesystem, we'll force it into
66 # /tmp which doesn't require root.  We'll be smart and get the desired
67 # rmr version from the repo root juas as we _expected_ the CI environmnt
68 # woudl do (but seems not to).
69 #
70 function ensure_pkgs {
71         if (( force_rmr_load )) || [[ -d /usr/local/include/rmr ]]
72         then
73                 echo "[INFO] found RMR installed in /usr/local"
74                 return
75         fi
76
77         rv=$( grep "version:" ../../rmr-version.yaml | awk '{ print $NF; exit( 0 ) }' )
78         rr=$( grep "repo:" ../../rmr-version.yaml | awk '{ print $NF; exit( 0 ) }' )
79         if [[ -z $rv ]]
80         then
81                 rv="4.2.1"                      # some sane version if not found
82         fi
83         if [[ -z $rr ]]
84         then
85                 rr="release"
86         fi
87         echo "[INFO] RMR seems not to be installed in /usr/local; pulling private copy: v=$rv"
88
89         pkg_dir=/tmp/ut_pkg
90         mkdir -p $pkg_dir
91
92         (
93                 set -e
94                 opts="-nv --content-disposition"
95                 url_base="https://packagecloud.io/o-ran-sc/$rr/packages/debian/stretch"
96                 cd /tmp
97                 wget $opts ${url_base}/rmr_${rv}_amd64.deb/download.deb
98                 wget $opts ${url_base}/rmr-dev_${rv}_amd64.deb/download.deb
99
100                 for x in *rmr*deb
101                 do
102                         dpkg -x $x $pkg_dir
103                 done
104         )
105         if (( $? != 0 ))
106         then
107                 echo "[FAIL] unable to install one or more RMR packages"
108                 exit 1
109         fi
110
111         LD_LIBRARY_PATH=$pkg_dir/usr/local/lib:$LD_LIBRARY_PATH
112         LIBRARY_PATH=$pkg_dir/usr/local/lib:$LIBRARY_PATH
113         export C_INCLUDE_PATH="$pkg_dir/usr/local/include:$C_INCLUDE_PATH"
114 }
115
116 # ------------------------------------------------------------------------------------------------
117
118 # these aren't set by default in some of the CI environments
119 #
120 export LD_LIBRARY_PATH=/usr/local/lib:$LD_LIBRARY_PATH
121 export LIBRARY_PATH=/usr/local/lib:$LIBRARY_PATH
122
123 running=/tmp/PID$$.running
124 force_rmr_load=0
125
126 while [[ $1 == -* ]]
127 do
128         case $1 in
129                 -f)     force_rmr_load=1;;
130
131                 *)      echo "unrecognised option: $1"
132                         exit 1
133                         ;;
134         esac
135
136         shift
137 done
138
139 if [[ $1 == "purge" ]]                  # just purge
140 then
141         purge_dirs
142         exit 0
143 fi
144
145 ensure_pkgs                                             # ensure that we have RMR; some CI environments are lacking
146
147 if ! make -B unit_test                  # ensure that it's fresh
148 then
149         echo "[FAIL] cannot make unit_test"
150         exit 1
151 fi
152 echo "unit test(s) successfully built"
153
154 setup_dirs
155
156 if [[ $1 == "set"* ]]                   # setup only
157 then
158         exit
159 fi
160
161 ./unit_test >/tmp/PID$$.utlog 2>&1 &
162 pid=$!
163 abort_after 60 $pid &
164 wait $pid
165 #if ! unit_test >/tmp/PID$$.utlog 2>&1
166 if (( $? != 0 ))
167 then
168         echo ">>>> wait popped"
169         rm -f $running
170         cat /tmp/PID$$.utlog
171         rm -f /tmp/PID$$.*
172         purge_dirs
173         exit 1
174 fi
175 rm -f $running
176
177 echo "[PASS] base unit tests all pass"
178 echo "[INFO] file/directory verification begins...."
179
180 # validate files that should have been created/copied
181
182 rc=0
183
184 ls -al /tmp/mc_listener_test/* >/tmp/PID$$.fdlog 2>&1
185
186 if [[ -e $copy_src ]]
187 then
188         echo "[FAIL] copy source test should have been unlinked but was there!"
189         rc=1
190 else
191         dest_md5=$( cat $copy_dest | md5sum )           # use cat so that filename doesn't factor in to output
192         if [[ $dest_md5 != $src_md5 ]]
193         then
194                 echo "[FAIL] md5 of copy test file didn't match soruce"
195                 cat $dest_md5
196                 echo "$dest_md5  $src_md5"
197                 rc=1
198         fi
199 fi
200 purge_dirs
201
202 if (( rc > 0 ))
203 then
204         cat /tmp/PID$$.fdlog
205 fi
206
207
208 show_coverage.ksh unit_test.c                                                           # compute coverage and generate .gcov files
209 echo "Coverage with discounting (raw values in parens)"
210 ./discount_chk.ksh $(ls *gcov|egrep -v "^test_|unit_test.c")
211
212
213 if (( rc > 0 ))
214 then
215         echo "[FAIL] overall test fails"
216 else
217         echo "[PASS] overall test passes"
218         rm -f *test*.gcov
219 fi
220
221 rm -f /tmp/PID$$.*
222 exit $rc